don/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path('', include('web.urls')),
    path('api/', include('don_api.urls')),
]

if settings.DEBUG:
    urlpatterns += [
        path('admin/', admin.site.urls),
        path("__debug__/", include("debug_toolbar.urls")),
    ]

web/urls.py
from django.conf import settings
from django.urls import path
from django.views import defaults as default_views
from django.views.generic.base import RedirectView

from .views.api import (
    APIListView, APIDetailView, APISpecificationView, APIAddView, 
    APIAddSuccessView, APIValidatorReportsView, OpenApiSpecGenerator
)
from .views.article import ArticleListView, ArticleDetailView
from .views.generic import TemplateView
from .views.index import IndexView
from .views.organization import OrganizationDetailView, OrganizationListView
from .views.repository import RepositoryListView, RepositoryAddView, RepositoryAddSuccessView
from .views.statistics import StatisticsView


app_name = "web"


urlpatterns = [
    path("", IndexView.as_view(), name="index"),
    path("apis", APIListView.as_view(), name="api_list"),
    path("apis/toevoegen", APIAddView.as_view(), name="api_add"),
    path("apis/toevoegen/succes", APIAddSuccessView.as_view(), name="api_add_success"),
    path("apis/<slug:api_id>", APIDetailView.as_view(), name="api_detail"),
    path("apis/<slug:api_id>/score-details", APIValidatorReportsView.as_view(), name="api_validator_reports"),
    path("apis/<slug:api_id>/specificatie/<str:environment_name>", APISpecificationView.as_view(),
         name="api_specification"),
    path("organisaties", OrganizationListView.as_view(), name="organization_list"),
    path("organisaties/<slug:slug>", OrganizationDetailView.as_view(), name="organization_detail"),
    path("repositorys", RepositoryListView.as_view(), name="repository_list"),
    path("artikelen", ArticleListView.as_view(), name="article_list"),
    path("artikelen/<slug:slug>", ArticleDetailView.as_view(), name="article_detail"),
    path("toevoegen/repository", RepositoryAddView.as_view(), name="repository_add"),
    path("toevoegen/repository/succes", RepositoryAddSuccessView.as_view(), name="repository_add_success"),
    path("statistieken", StatisticsView.as_view(), name="statistics"),
    path("tools/oas-generator", OpenApiSpecGenerator.as_view(), name="oas_generator"),
    path("contact", TemplateView.as_view(title="Contact", template_name="contact.html"), name="contact"),
    path("over", TemplateView.as_view(
        title="Over Developer Overheid",
        description="Eén centrale plek voor de developer die voor of met de overheid ontwikkelt",
        template_name="content/about.html",
    ), name="content_about"),
    path("privacy", TemplateView.as_view(title="Privacyverklaring", template_name="content/privacy.html"),
         name="content_privacy"),
    path(".well-known/security.txt", RedirectView.as_view(url="https://www.ncsc.nl/.well-known/security.txt")),
]


if settings.DEBUG:
    urlpatterns += [
        path("error/400", default_views.bad_request, {"exception": Exception("Bad request")}),
        path("error/404", default_views.page_not_found, {"exception": Exception("Page not Found")}),
        path("error/500", default_views.server_error),
    ]

core/models/api.py
from django.db import models
from django.urls import reverse
from django.utils.translation import gettext_lazy as _

from . import MAX_ENUM_LENGTH, MAX_TEXT_LENGTH, MAX_URL_LENGTH

from .organization import Organization
from .topic import Topic
from .validator import ForeignValidatorReport, BaseValidatorReport, ValidatorReportsMixin


class API(ValidatorReportsMixin["APIValidatorReport"], models.Model):
    class APIType(models.TextChoices):
        UNKNOWN = 'unknown', 'Onbekend'
        ODATA = 'odata', 'OData'
        REST_JSON = 'rest_json', 'REST/JSON'
        REST_XML = 'rest_xml', 'REST/XML'
        SOAP_XML = 'soap_xml', 'SOAP/XML'
        GRPC = 'grpc', 'gRPC'
        GRAPHQL = 'graphql', 'GraphQL'
        SPARQL = 'sparql', 'SPARQL'
        WFS = 'wfs', 'WFS'
        WMS = 'wms', 'WMS'

    class APIAuthentication(models.TextChoices):
        UNKNOWN = 'unknown', 'Unknown'
        NONE = 'none', 'None'
        MUTUAL_TLS = 'mutual_tls', 'Mutal TLS'
        API_KEY = 'api_key', 'API key'
        IP_ALLOW_LIST = 'ip_allow_list', 'IP allow list'
        OAUTH2 = "oauth2", "OAuth 2.0"

    api_id = models.CharField(max_length=MAX_TEXT_LENGTH, unique=True)
    description = models.TextField()
    organization = models.ForeignKey(
        Organization, verbose_name=_("organization"), on_delete=models.PROTECT)
    service_name = models.CharField(max_length=MAX_TEXT_LENGTH)
    api_type = models.CharField(
        max_length=MAX_ENUM_LENGTH,
        choices=APIType.choices,
        default=APIType.UNKNOWN
    )
    api_authentication = models.CharField(
        max_length=MAX_ENUM_LENGTH,
        choices=APIAuthentication.choices,
        default=APIAuthentication.UNKNOWN
    )
    is_reference_implementation = models.BooleanField(default=False)

    contact_email = models.CharField(max_length=MAX_TEXT_LENGTH, blank=True)
    contact_phone = models.CharField(max_length=MAX_TEXT_LENGTH, blank=True)
    contact_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)

    terms_government_only = models.BooleanField(null=True)
    terms_pay_per_use = models.BooleanField(null=True)
    terms_uptime_guarantee = models.DecimalField(
        null=True,
        decimal_places=6,
        max_digits=8,
    )
    terms_support_response_time = models.PositiveIntegerField(
        help_text='Measured in number of workdays',
        null=True,
    )

    forum_vendor = models.CharField(max_length=MAX_ENUM_LENGTH, blank=True)
    forum_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)

    discourse_topic_url = models.CharField(max_length=MAX_URL_LENGTH, blank=True)

    badges = models.ManyToManyField(
        'Badge',
        through='APIBadge',
        related_name='apis',
    )
    referenced_apis = models.ManyToManyField(
        'self',
        through='Relation',
        symmetrical=False,
        related_name='referenced_by_apis',
    )
    topics = models.ManyToManyField(Topic)

    def __str__(self):
        return self.api_id

    def get_absolute_url(self):
        return reverse("web:api_detail", kwargs={"api_id": self.api_id})

    def get_production_environment(self):
        return self.environments.filter(name=Environment.EnvironmentType.PRODUCTION).first()

    ADR_TESTABLE_TYPES = (APIType.REST_JSON.ODATA, APIType.REST_JSON, APIType.REST_XML)
    """API's of these types can be tested on API Design Rules"""

    def is_adr_testable(self):
        return self.api_type in self.ADR_TESTABLE_TYPES

    class Meta:
        verbose_name = _("API")
        verbose_name_plural = _("APIs")


class Environment(models.Model):
    class EnvironmentType(models.TextChoices):
        PRODUCTION = 'production', 'Production'
        ACCEPTANCE = 'acceptance', 'Acceptance'
        TEST = 'test', 'Test'
        DEMO = 'demo', 'Demo'

    name = models.CharField(max_length=MAX_ENUM_LENGTH, choices=EnvironmentType.choices)
    api_url = models.URLField(max_length=MAX_URL_LENGTH)
    specification_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)
    documentation_url = models.URLField(max_length=MAX_URL_LENGTH, blank=True)

    api = models.ForeignKey(
        API,
        to_field='api_id',
        on_delete=models.CASCADE,
        related_name='environments',
    )

    def __str__(self):
        return f"{self.name} - {self.api_url}"


class Relation(models.Model):
    TYPE_REFERENCE_IMPLEMENTATION = "reference-implementation"

    name = models.CharField(max_length=MAX_TEXT_LENGTH, blank=True)
    from_api = models.ForeignKey(
        API,
        to_field='api_id',
        on_delete=models.CASCADE,
        related_name='relations_from',
    )
    to_api = models.ForeignKey(
        API,
        to_field='api_id',
        on_delete=models.PROTECT,
        related_name='relations_to',
    )

    def __str__(self):
        return f'{self.from_api_id} {self.name} {self.to_api_id}'


class APIValidatorReport(BaseValidatorReport):
    api = ForeignValidatorReport(API)

core/models/topic.py
from django.db import models

from . import MAX_TEXT_LENGTH


class Topic(models.Model):
    name = models.CharField(max_length=MAX_TEXT_LENGTH, unique=True)

    def __str__(self):
        return self.name

web/views/statistics.py
from collections import defaultdict
from datetime import timedelta

from django.core.exceptions import BadRequest
from django.utils import dateformat, translation
from influxdb_client.client.flux_table import FluxRecord, TableList

from core.models.validator import ValidatorRuleset
from core.models.repository import RepositoryProgrammingLanguage, get_programming_languages_count
from .generic import TemplateView
from ..statistics import get_statistics, serialize_design_rules_api_successes


class StatisticsView(TemplateView):
    template_name = "statistics.html"
    title = "Statistieken"

    time_ranges = {
        "laatste-maand": (-30, timedelta(days=1)),
        "laatste-jaar": (-365, timedelta(days=30)),
    }
    default_time_range = "laatste-maand"

    def get(self, request, *args, **kwargs):
        time_range_value = request.GET.get("periode")
        if time_range_value is None:
            time_range_value = self.default_time_range
        if time_range_value not in self.time_ranges:
            raise BadRequest(f"Invalid value for 'periode' parameter: {time_range_value}")

        self.time_range = time_range_value
        self.start_days, self.window_every = self.time_ranges[time_range_value]

        return super().get(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)

        total_counts, api_design_rules_tables, design_rules_api_successes_last = (
            get_statistics(self.start_days, self.window_every))

        api_design_rules_per_rule = defaultdict(dict)
        for table in api_design_rules_tables:
            for record in table.records:
                name = record["rule"]
                api_design_rules_per_rule[name][record.get_field()] = int(record.get_value())

        def map_api_design_rules_per_rule():
            core_ruleset_rules = dict(
                ValidatorRuleset.objects
                .values_list('rules__rule_id', 'rules__title')
                .filter(ruleset_id="core").all())

            for rule_id, fields in api_design_rules_per_rule.items():
                rule_title = core_ruleset_rules.get(rule_id, '')  # return empty title for dummy data
                percentage = int((fields["success_count"] / fields["total_count"]) * 100)
                yield rule_id, rule_title, percentage

        totals_labels, totals_series = _group_totals(total_counts)

        def get_totals(name):
            return {"labels": totals_labels[name], "series": totals_series[name]}
        
        repository_programming_languages = RepositoryProgrammingLanguage.objects.select_related(
            "programming_language",
        ).all()
        
        context["top_programming_languages"] = get_programming_languages_count(repository_programming_languages)[:40]
        context["time_range"] = self.time_range
        context["api_design_rules_per_rule"] = map_api_design_rules_per_rule
        context["graph_data"] = {
            "api-design-rules-per-score": serialize_design_rules_api_successes(design_rules_api_successes_last),
            "organization-totals": get_totals("organization"),
            "api-totals": get_totals("api"),
            "repository-totals": get_totals("repository"),
        }

        return context


def _group_totals(tables: TableList):
    labels = defaultdict(list)
    series = defaultdict(list)

    with translation.override(language="nl_NL"):
        for table in tables:
            record: FluxRecord
            for record in table.records:
                # In the frond-end the counts are displayed per day only.
                # So we're shifting the time of the metric with with 1 day and use only the date part.
                # This is tied to the Influx query because of the grouping per day.
                #
                # 2022-07-04 00:00:00+00:00 -> 2022-07-03
                date = (record.get_time() - timedelta(days=1)).date()

                labels[record.get_measurement()].append(dateformat.format(date, "j N"))
                series[record.get_measurement()].append(int(record.get_value()))

    return labels, series

web/templates/api_add_success.html
{% extends "layouts/base.html" %}
{% load static i18n don_extras %}

{% block content %}
<h1 class="mb-6">{{ title }}</h1>
<p class="font-size-lg">API is toegevoegd. Deze wordt zo snel mogelijk geplaatst.</p>
{% endblock %}

web/templates/api_detail.html
{% extends "layouts/base.html" %}
{% load static i18n don_extras %}

{% block content %}
    <div class="page-api-detail mb-md">
        <div class="api-top-content">
            <div class="title-row mb-xs">
                <h1 class="page-title mb-0">{{ title }}</h1>
                <span class="pill pill--white hide-upto-sm">{{ api.get_api_type_display }}</span>
            </div>
            <a href="{{ api.organization.get_absolute_url }}" class="page-subtitle mb-md">{{ api.organization.name }}</a>
            <p class="intro">{{ api.description }}</p>
            <span class="pill pill--white hide-from-sm">{{ api.get_api_type_display }}</span>
            {% if api.discourse_topic_url %}
            <a class="button button--tertiary"
                href="{{ api.discourse_topic_url }}"
                data-goatcounter-click="event:api-goto-discourse-topic:{{ api.api_id }}"
                data-goatcounter-title="'Naar community topic' knop"
                data-goatcounter-referrer="{{ request.build_absolute_uri }}">
                <svg class="buton__icon button__icon--first icon icon--md" aria-hidden="true">
                    <use xlink:href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-messages" />
                </svg>
                Naar community topic
            </a>
            {% endif %}
            <div class="api-topics">
                <p class="mt-0 mb-2 font-description-term">Thema's</p>
                {% if api.topics.all %}
                {% include "partials/topic_list.html" with topics=api.topics.all cssClass="topic-list--multiple-lines" %}
                {% else %}
                <i>Geen thema's ingevuld.</i>
                {% endif %}
            </div>
        </div>
        <dl class="api-props vertical-sm mt-md mb-md">
            <div>
                <dt>API Authenticatie</dt>
                <dd>
                    {{ api.api_authentication | format_api_authentication }}
                </dd>
            </div>
            <div>
                <dt>Gebruik</dt>
                <dd>
                    {% if api.terms_government_only %}
                    Alleen overheid
                    {% else %}
                    Iedereen
                    {% endif %}
                </dd>
            </div>
            <div>
                <dt>Kosten</dt>
                <dd>
                    {% if api.terms_pay_per_use %}
                    Kosten voor gebruik
                    {% else %}
                    Gratis
                    {% endif %}
                </dd>
            </div>
            <div>
                <dt>Uptime garantie</dt>
                <dd>
                    {% if api.terms_uptime_guarantee %}
                    {% language "nl" %}
                    {{ api.terms_uptime_guarantee | floatformat:-2 }}{% endlanguage %}%
                    {% else %}
                    Geen
                    {% endif %}
                </dd>
            </div>
            <div>
                <dt>Helpdesk respons</dt>
                <dd>
                    {% if api.terms_support_response_time %}
                    {{ api.terms_support_response_time }}
                    werkdag{{ api.terms_support_response_time | pluralize:"en" }}
                    {% else %}
                    Geen
                    {% endif %}
                </dd>
            </div>
        </dl>
        <a
        class="edit-link mt-0 mb-lg"
        target="_blank"
        href="https://gitlab.com/commonground/don/don-content/-/blob/main/content/api/{{ api.api_id }}.yaml"
        rel="noopener noreferrer"
        data-goatcounter-click="event:api-edit-content:{{ api.api_id }}"
        data-goatcounter-title="'Pas content aan' knop"
        data-goatcounter-referrer="{{ request.build_absolute_uri }}"
        >
            <svg class="buton__icon button__icon--first icon icon--md" aria-hidden="true">
                <use xlink:href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-edit" />
            </svg>
            Pas content aan op Gitlab
        </a>
        <div class="environments card card--padding-md mb-md">
            <h2>Omgevingen</h2>
            {% for environment in api.environments.all %}
            <div class="environments__env">
                <h3>{{ environment.name }}</h3>
                <div class="environments__env__urls">
                    <code class="code">{{ environment.api_url }}</code>
                    {% if environment.specification_url %}
                    <a href="{% url 'web:api_specification' api.api_id environment.name %}"
                        class="button">Specificatie</a>
                    {% else %}
                    <span class="button button--disabled">Specificatie</span>
                    {% endif %}
                    {% if environment.documentation_url %}
                    <a href="{{ environment.documentation_url }}"
                        class="button button--external-link"
                        target="_blank"
                        rel="noopener noreferrer">Documentatie
                        <img src="{% static 'images/icons/external-link.svg' %}"
                            width="16"
                            height="16"
                            alt="">
                    </a>
                    {% else %}
                    <span class="button button--disabled">Documentatie</span>
                    {% endif %}
                </div>
            </div>
            {% endfor %}
        </div>
        {% if api.forum_url %}
        <div class="forum">
            <h2>Community</h2>
            <a href="{{ api.forum_url }}"
                class="button button--external-link ml-4"
                target="_blank"
                rel="noopener noreferrer">Ga naar community
                <img src="{% static 'images/icons/external-link.svg' %}"
                    width="16"
                    height="16"
                    alt="">
            </a>
        </div>
        {% endif %}
        {% with repository_list=api.related_repositories.all %}
        {% if repository_list %}
        <div class="related-repositories card mb-lg">
            <h2>Code</h2>
            <p>
                {{ repository_list | length }} open source
                {% if repository_list.count == 1 %}
                project gebruikt
                {% else %}
                projecten gebruiken
                {% endif %}
                deze API
            </p>
            <ul class="list-reset">
                {% for repository in repository_list %}
                {% repository_item repository %}
                {% endfor %}
            </ul>
        </div>
        {% endif %}
        {% endwith %}
        {% if implemented_by_api_list %}
        <div class="related-apis card card--padding-md mb-md">
            <h2>Geïmplementeerd door</h2>
            <ul class="list-reset">
                {% for api in implemented_by_api_list %}
                {% include "partials/api_item.html" with api=api cssClass="card" %}
                {% empty %}Er zijn momenteel geen API's die verwijzen naar deze referentie-implementatie.
                {% endfor %}
            </ul>
        </div>
        {% elif implemented_for_api_list %}
        <div class="related-apis card card--padding-md mb-lg">
            <h2>
                Referentie implementatie{{ implemented_for_api_list | pluralize:"s" }}
            </h2>
            <ul class="list-reset">
                {% for api in implemented_for_api_list %}
                {% include "partials/api_item.html" with api=api %}
                {% endfor %}
                </ul>
                </div>
                {% endif %}
        {% if api.latest_validator_reports.count %}
        <h2 class="mt-md">API scores</h2>
        {% include "partials/validator_reports_summary.html" with validator_reports=api.latest_validator_reports %}
        <a href="{% url 'web:api_validator_reports' api_id=api.api_id %}" class="button button--primary mb-md align-self-end">
            API score details
            <svg class="button__icon button__icon--last button__icon--small-width">
                <use xlink:href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-chevron-right" />
            </svg>
        </a>
        {% endif %}
    </div>
{% endblock %}

web/templates/api_list.html
{% extends "layouts/base.html" %}
{% load static %}

{% block content %}
<h1 class="mb-5">{{ title }}</h1>
<p class="mb-0">{{ description }}</p>
<div id="list-results" class="page-search">
    {% include "partials/api_list_results.html" %}
</div>
{% endblock %}

{% block tail %}
<script src="{% static 'dist/htmx.js' %}"></script>
{% endblock %}

web/templates/index.html
{% extends "layouts/base.html" %}
{% load static don_extras %}

{% block content %}
<div class="page-homepage">
    <div class="hero py-xl">
        <div class="hero--bg">
            <img src="{% static 'images/hero_bg.webp' %}">
        </div>
        <div class="container">
            <div class="hero__intro">
                <h1 class="hero__intro__heading">Eén centrale plek voor de developer die voor of met de overheid
                    ontwikkelt</h1>
                <p class="hero__intro__subtitle">
                    Handige bronnen en de community
                    voor de ontwikkeling van jouw digitale services.
                </p>
            </div>
            <div class="hero__content">
                <a href="https://community.developer.overheid.nl/" class="card card--call-to-action" target="_blank" rel="noopener noreferrer"  aria-label="Onze community">
                    <div class="card__icon">
                        <svg width="60" height="60">
                            <use xlink:href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-messages" />
                        </svg>
                    </div>
                    <h2 class="card__title">Onze community</h2>
                    <p class="card__description">Ga in gesprek met andere developers en vind hier getting started guides, tutorials en tools.</p>
                    <div class="card__footer">
                        <svg class="card__footer__icon mr-3" width="16" height="17" viewBox="0 0 16 17" fill="none"
                            xmlns="http://www.w3.org/2000/svg" aria-hidden="true">
                            <path
                                d="M6.67969 1.60547L7.45312 0.832031C7.80469 0.515625 8.33203 0.515625 8.64844 0.832031L15.5039 7.65234C15.8203 8.00391 15.8203 8.53125 15.5039 8.84766L8.64844 15.7031C8.33203 16.0195 7.80469 16.0195 7.45312 15.7031L6.67969 14.9297C6.36328 14.5781 6.36328 14.0508 6.67969 13.6992L10.9336 9.65625H0.84375C0.351562 9.65625 0 9.30469 0 8.8125V7.6875C0 7.23047 0.351562 6.84375 0.84375 6.84375H10.9336L6.67969 2.83594C6.36328 2.48438 6.32812 1.95703 6.67969 1.60547Z"
                            />
                        </svg>
                        <span class="card__footer__text">Naar community</span>
                    </div>
                </a>
                <a href="{% url 'web:api_list' %}" class="card card--call-to-action">
                    <div class="card__icon">
                        <svg width="60" height="60">
                            <use xlink:href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-affiliate" />
                        </svg>
                    </div>
                    <h2 class="card__title">Vind een API</h2>
                    <p class="card__description">Bekijk welke API's er allemaal zijn en kom er achter hoe je jouw
                        oplossing hier op kan laten aansluiten.</p>
                    <div class="card__footer">
                        <svg class="card__footer__icon mr-3" width="16" height="17" viewBox="0 0 16 17" fill="none"
                            xmlns="http://www.w3.org/2000/svg" aria-hidden="true">
                            <path
                                d="M6.67969 1.60547L7.45312 0.832031C7.80469 0.515625 8.33203 0.515625 8.64844 0.832031L15.5039 7.65234C15.8203 8.00391 15.8203 8.53125 15.5039 8.84766L8.64844 15.7031C8.33203 16.0195 7.80469 16.0195 7.45312 15.7031L6.67969 14.9297C6.36328 14.5781 6.36328 14.0508 6.67969 13.6992L10.9336 9.65625H0.84375C0.351562 9.65625 0 9.30469 0 8.8125V7.6875C0 7.23047 0.351562 6.84375 0.84375 6.84375H10.9336L6.67969 2.83594C6.36328 2.48438 6.32812 1.95703 6.67969 1.60547Z"
                             />
                        </svg>
                        <span class="card__footer__text">Zoek API's</span>
                    </div>
                </a>
                <a href="{% url 'web:repository_list' %}"
                    class="card card--call-to-action">
                    <div class="card__icon">
                        <svg width="60" height="60">
                            <use xlink:href="{% static 'images/icons/tabler-sprite.svg' %}#tabler-notebook" />
                        </svg>
                    </div>
                    <h2 class="card__title">Vind een repository</h2>
                    <p class="card__description">Vind bestaande repository's om bij aan te haken en ontdek wat er binnen
                        welke organisatie beschikbaar is.</p>
                    <div class="card__footer">
                        <svg class="card__footer__icon mr-3" width="16" height="17" viewBox="0 0 16 17" fill="none"
                            xmlns="http://www.w3.org/2000/svg" aria-hidden="true">
                            <path
                                d="M6.67969 1.60547L7.45312 0.832031C7.80469 0.515625 8.33203 0.515625 8.64844 0.832031L15.5039 7.65234C15.8203 8.00391 15.8203 8.53125 15.5039 8.84766L8.64844 15.7031C8.33203 16.0195 7.80469 16.0195 7.45312 15.7031L6.67969 14.9297C6.36328 14.5781 6.36328 14.0508 6.67969 13.6992L10.9336 9.65625H0.84375C0.351562 9.65625 0 9.30469 0 8.8125V7.6875C0 7.23047 0.351562 6.84375 0.84375 6.84375H10.9336L6.67969 2.83594C6.36328 2.48438 6.32812 1.95703 6.67969 1.60547Z"
                            />
                        </svg>
                        <span class="card__footer__text">Zoek repository's</span>
                    </div>
                </a>
            </div>
        </div>
    </div>
    {% if article_list %}
    <div class="container my-xl">
        <h2>Laatste artikelen</h2>
        {% include "partials/article_list.html" with columns=3 %}
        <a href="{% url 'web:article_list' %}" class="button">
            Bekijk alle artikelen
        </a>
    </div>
    {% endif %}
</div>
{% endblock %}

web/templates/repository_add.html
{% extends "layouts/base.html" %}
{% load i18n %}

{% block content %}
<div class="column-60 page-repository-add">
    <h1 class="mb-5">{{ title }}</h1>
    <p>
        Laat je repository's toevoegen door onderstaand formulier in te vullen.
        Het is ook mogelijk om een <a href="https://gitlab.com/commonground/don/don-content/-/merge_requests" target="_blank" rel="noopener noreferrer">merge request</a> aan te maken.
    </p>
    <p>
        We hebben alleen de URL van je GitLab of GitHub-organisatieaccount nodig omdat we daarmee de repository's automatisch op kunnen halen.
        Let op: persoonlijke accounts kunnen niet worden toegevoegd omdat we die niet ondersteunen.
    </p>
    <div class="card card--padding-lg">
        {% language "nl" %}
            <form action="{% url 'web:repository_add' %}" method="post" class="add-repository-form">
                {% csrf_token %}
                {% if form.errors  %}<p class="warning">Het formulier is nog niet volledig ingevuld en/of bevat fouten.</p>{% endif %}
                <div class="field-wrapper">
                    {% if form.organization_ooid.field.has_choices %}
                        <label for="{{ form.organization_ooid.id_for_label }}">Organisatie</label>
                        <p class="information-source">We halen de lijst van organisaties uit het {% include "partials/external_link.html" with href="https://organisaties.overheid.nl/" title="Register van Overheidsorganisaties" %}</p>
                        {{ form.organization_ooid }}
                        {% if form.organization_ooid.errors %}
                            <div class="field-wrapper__errors">{{ form.organization_ooid.errors }}</div>
                        {% endif %}
                    {% else %}
                        <label for="{{ form.organization_name.id_for_label }}">Organisatienaam</label>
                        {{ form.organization_name }}
                        {% if form.organization_name.errors %}
                            <div class="field-wrapper__errors">{{ form.organization_name.errors }}</div>
                        {% endif %}
                    {% endif %}
                </div>
                <div class="field-wrapper">
                    <label for="{{ form.account_url.id_for_label }}">GitLab- of GitHub-acount</label>
                    <p>De URL naar het organisatieaccount op GitLab of GitHub.<br>Deze moet beginnen met 'https://'.</p>
                    {{ form.account_url }}
                    {% if form.account_url.errors %}<div class="field-wrapper__errors">{{ form.account_url.errors }}</div>{% endif %}
                </div>
                <button type="submit" class="button button--primary">Account registreren</button>
            </form>
        {% endlanguage %}
    </div>
</div>
{% endblock %}